<?php // by WebMan v.7 (03.08.2014)

class formAdminDebug extends cmsForm {

    public $is_tabbed = true;

    public function init() {

        return array(

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG,
                'childs' => array(

                    new fieldCheckbox('debug_on', array(
                        'title' => LANG_CP_DEBUG_ON,
                        'hint' => LANG_CP_DEBUG_ON_HINT,
                    )),                            

                    new fieldCheckbox('debug_admin_only', array(
                        'title' => LANG_CP_DEBUG_ADMIN_ONLY,
                        'hint' => "<br/><hr>",
                    )),                            

                    new fieldCheckbox('memory_real_usage', array(
                        'title' => LANG_CP_DEBUG_MEMORY_REAL_USAGE,
                    )),

                    new fieldNumber('emulate_lag', array(
                        'title' => LANG_CP_DEBUG_EMULATE_LAG,
                        'default' => 0,
                        'rules' => array(
                            array('min', 0),
                            array('max', 10000),
                        )
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG_BLOCK_ERROR,
                'childs' => array(

                    new fieldCheckbox('debug_on_error', array(
                        'title' => LANG_CP_DEBUG_ON_ERROR,
                        'hint' => LANG_CP_DEBUG_ON_ERROR_HINT,
                    )),

                    new fieldCheckbox('error_display', array(
                        'title' => LANG_CP_DEBUG_ERROR_DISPLAY,
                    )),

                    new fieldCheckbox('error_log_data', array(
                        'title' => LANG_CP_DEBUG_ERROR_LOG_DATA,
                    )),

                    new fieldNumber('error_critical_user', array(
                        'title' => LANG_CP_DEBUG_ERROR_CRITICAL_USER,
                        'default' => 1,
                        'rules' => array(
                            array('min', 1),
                        )
                    )),

                    new fieldCheckbox('error_critical_mail', array(
                        'title' => LANG_CP_DEBUG_ERROR_CRITICAL_MAIL,
                    )),

                    new fieldCheckbox('error_critical_msg', array(
                        'title' => LANG_CP_DEBUG_ERROR_CRITICAL_MSG,
                    )),

                    new fieldCheckbox('error_critical_notice', array(
                        'title' => LANG_CP_DEBUG_ERROR_CRITICAL_NOTICE,
                    )),

                    new fieldString('error_critical_page', array(
                        'title' => LANG_CP_DEBUG_ERROR_CRITICAL_PAGE,
                    )),

                    new fieldList('trace_level_error', array(
                        'title' => LANG_CP_DEBUG_TRACE_LEVEL_ERROR,
                        'items' => $this->getTraceLevels(),
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG_BLOCK_POINT,
                'childs' => array(

                    new fieldCheckbox('debug_on_point', array(
                        'title' => LANG_CP_DEBUG_ON_POINT,
                    )),

                    new fieldList('trace_level_point', array(
                        'title' => LANG_CP_DEBUG_TRACE_LEVEL_POINT,
                        'items' => $this->getTraceLevels(),
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG_BLOCK_SQL,
                'childs' => array(

                    new fieldCheckbox('debug_on_sql', array(
                        'title' => LANG_CP_DEBUG_ON_SQL,
                    )),

                    new fieldString('filter_query_sql', array(
                        'title' => LANG_CP_DEBUG_FILTER_QUERY_SQL,
                    )),

                    new fieldString('filter_query_from', array(
                        'title' => LANG_CP_DEBUG_FILTER_QUERY_FROM,
                    )),

                    new fieldNumber('query_heavy', array(
                        'title' => LANG_CP_DEBUG_QUERY_HEAVY,
                    )),

                    new fieldList('trace_level_sql', array(
                        'title' => LANG_CP_DEBUG_TRACE_LEVEL_SQL,
                        'items' => $this->getTraceLevels(),
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG_BLOCK_AUTO,
                'childs' => array(

                    new fieldCheckbox('debug_on_auto', array(
                        'title' => LANG_CP_DEBUG_ON_AUTO,
                    )),

                    new fieldString('filter_auto_file', array(
                        'title' => LANG_CP_DEBUG_FILTER_AUTO_FILE,
                    )),

                    new fieldString('filter_auto_from', array(
                        'title' => LANG_CP_DEBUG_FILTER_AUTO_FROM,
                    )),

                    new fieldList('trace_level_auto', array(
                        'title' => LANG_CP_DEBUG_TRACE_LEVEL_AUTO,
                        'items' => $this->getTraceLevels(),
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG_BLOCK_INCLUDE,
                'childs' => array(

                    new fieldCheckbox('debug_on_include', array(
                        'title' => LANG_CP_DEBUG_ON_INCLUDE,
                    )),

                    new fieldCheckbox('includes_table_error', array(
                        'title' => LANG_CP_DEBUG_INCLUDES_TABLE_ERROR,
                    )),

                    new fieldString('filter_include_file', array(
                        'title' => LANG_CP_DEBUG_FILTER_INCLUDE_FILE,
                    )),

                    new fieldString('filter_include_from', array(
                        'title' => LANG_CP_DEBUG_FILTER_INCLUDE_FROM,
                    )),

                    new fieldList('trace_level_include', array(
                        'title' => LANG_CP_DEBUG_TRACE_LEVEL_INCLUDE,
                        'items' => $this->getTraceLevels(),
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG_BLOCK_HOOK,
                'childs' => array(

                    new fieldCheckbox('debug_on_hook', array(
                        'title' => LANG_CP_DEBUG_ON_HOOK,
                    )),

                    new fieldCheckbox('hook_log_data', array(
                        'title' => LANG_CP_DEBUG_HOOK_LOG_DATA,
                    )),

                    new fieldList('hook_table', array(
                        'title' => LANG_CP_DEBUG_HOOK_TABLE,
                        'items' => array(
                            'none'          => LANG_CP_DEBUG_HOOK_TABLE_NONE,
                            'act_hooks'     => LANG_CP_DEBUG_HOOK_TABLE_ACT_HOOKS,
                            'act_controls'  => LANG_CP_DEBUG_HOOK_TABLE_ACT_CONTROLS,
                            'all_hooks'     => LANG_CP_DEBUG_HOOK_TABLE_ALL_HOOKS,
                            'all_controls'  => LANG_CP_DEBUG_HOOK_TABLE_ALL_CONTROLS,
                            'list_events'   => LANG_CP_DEBUG_HOOK_TABLE_LIST_EVENTS,
                            'list_hooks'    => LANG_CP_DEBUG_HOOK_TABLE_LIST_HOOKS,
                            'list_controls' => LANG_CP_DEBUG_HOOK_TABLE_LIST_CONTROLS,
                        )
                    )),

                    new fieldList('filter_hook_event', array(
                        'title' => LANG_CP_DEBUG_FILTER_HOOK_EVENT,
                        'generator' => function($item) {

                            $items = array(
                                'none' => LANG_CP_DEBUG_FILTER_NONE,
                            );

                            $listeners = cmsEventsManager::getAllListeners();

                            foreach ($listeners as $event => $val) {
                                $events[$event] = $event;
                            }

                            ksort($events);
                            $items = array_merge($items, $events);

                            return $items;
                        }
                    )),

                    new fieldList('filter_hook_control', array(
                        'title' => LANG_CP_DEBUG_FILTER_HOOK_CONTROL,
                        'generator' => function($item) {

                            $items = array(
                                'none' => LANG_CP_DEBUG_FILTER_NONE,
                            );

                            $manifests = cmsCore::getControllersManifests();

                            foreach ($manifests as $controller_name => $val) {
                                $controllers[$controller_name] = $controller_name;
                            }

                            ksort($controllers);
                            $items = array_merge($items, $controllers);

                            return $items;

                        }
                    )),

                    new fieldNumber('hook_heavy', array(
                        'title' => LANG_CP_DEBUG_HOOK_HEAVY,
                    )),

                    new fieldList('trace_level_hook', array(
                        'title' => LANG_CP_DEBUG_TRACE_LEVEL_HOOK,
                        'items' => $this->getTraceLevels(),
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG_BLOCK_WIDGET,
                'childs' => array(

                    new fieldCheckbox('debug_on_widget', array(
                        'title' => LANG_CP_DEBUG_ON_WIDGET,
                    )),

                    new fieldCheckbox('widget_log_data', array(
                        'title' => LANG_CP_DEBUG_WIDGET_LOG_DATA,
                    )),

                    new fieldCheckbox('widget_table_active', array(
                        'title' => LANG_CP_DEBUG_WIDGET_TABLE_ACTIVE,
                    )),

                    new fieldList('filter_widget_widget', array(
                        'title' => LANG_CP_DEBUG_FILTER_WIDGET_WIDGET,
                        'generator' => function($item) {

                            $items = array(
                                'none' => LANG_CP_DEBUG_FILTER_NONE,
                            );

                            $widgets_list = cmsCore::getModel('widgets')->getAvailableWidgets();

                            foreach ($widgets_list as $controller => $widgets) {
                                foreach ($widgets as $key => $val) {
                                    $list[$val['name']] = $val['name'];
                                }
                            }

                            ksort($list);
                            $items = array_merge($items, $list);

                            return $items;
                        }
                    )),

                    new fieldList('filter_widget_control', array(
                        'title' => LANG_CP_DEBUG_FILTER_WIDGET_CONTROL,
                        'generator' => function($item) {

                            $items = array(
                                'none' => LANG_CP_DEBUG_FILTER_NONE,
                            );

                            $widgets_list = cmsCore::getModel('widgets')->getAvailableWidgets();

                            foreach ($widgets_list as $c => $widgets) {
                                foreach ($widgets as $key => $val) {
                                    $controller = $val['controller'];
                                    if ($controller) {
                                        $list[$controller] = $controller;
                                    } else {
                                        $list[$controller] = LANG_CP_DEBUG_FILTER_EMPTY;
                                    }
                                }
                            }

                            ksort($list);
                            $items = array_merge($items, $list);

                            return $items;
                        }
                    )),

                    new fieldNumber('widget_heavy', array(
                        'title' => LANG_CP_DEBUG_WIDGET_HEAVY,
                    )),

                    new fieldList('trace_level_widget', array(
                        'title' => LANG_CP_DEBUG_TRACE_LEVEL_WIDGET,
                        'items' => $this->getTraceLevels(),
                    )),

                )

            ),

            array(
                'type' => 'fieldset',
                'title' => LANG_CP_DEBUG_BLOCK_CACHE,
                'childs' => array(

                    new fieldCheckbox('debug_on_cache', array(
                        'title' => LANG_CP_DEBUG_ON_CACHE,
                    )),                            

                    new fieldList('trace_level_cache', array(
                        'title' => LANG_CP_DEBUG_TRACE_LEVEL_CACHE,
                        'items' => $this->getTraceLevels(),
                    )),

                )

            ),

        );

    }

    // Возвращает список уровней трассировки
    public function getTraceLevels() {
        $items = array();
        for ($i=0; $i<=19; $i++) {
            $items[$i] = $i;
        }
        return $items;
    }
}
